macro calibration(device, calibration_data)
    @eval begin
        """
        `$($device)`
        """
        calibration(::Val{$device}) = $calibration_data
    end
end

calibration(::Val{:empty}) = []


function load_config()
    if !data_loaded[]
        function_call_root_dir = @__DIR__
        @info function_call_root_dir

        config_file_relative_path = "calibration/config.jl"
        config_file_paths = String[]
        push!(config_file_paths, joinpath(pwd(), config_file_relative_path));
        push!(config_file_paths, joinpath(function_call_root_dir, config_file_relative_path))
        push!(config_file_paths, joinpath(function_call_root_dir, "..", config_file_relative_path))

        for file_path in config_file_paths
            if isfile(file_path)
                @info "Calibration directory found at " * file_path
                include(file_path)
                data_loaded[] = true
                return
            else
                @warn "Calibration directory not found at " * file_path
            end
        end
    else
        @info "Calibration has already been loaded"
    end
end


function get_calibration(hydro_id, preamp_id = :empty)
    call_calibration(s) = Base.invokelatest(calibration, Val(s))
    return call_calibration(hydro_id), call_calibration(preamp_id)
end
